#!/bin/sh
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# some O.S dependencies
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
phlib_OSNAME=`uname -s`;export phlib_OSNAME
if [ $phlib_OSNAME = "Linux" ] ; then
   phlib_AWKNAME="/usr/bin/awk";export phlib_AWKNAME;

elif test $phlib_OSNAME = "SunOS" ; then 
   phlib_AWKNAME="nawk";export phlib_AWKNAME;
else
   # hope for the best
   phlib_AWKNAME="awk";export phlib_AWKNAME;
fi


# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
phlib_debug()
{
echo $1
}

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


# ........................................................................
# strip ./ or ../ if the string begins with one of them.
# the string is returned in the variable:
#                                        phlib_ret_strip_dot_slash
# ........................................................................
phlib_strip_dot_slash()
{
_WHERE=$1

phlib_ret_strip_dot_slash=`echo $_WHERE | 
    $phlib_AWKNAME '{ sub("^\./","",$0); sub("^\.\./","",$0); printf "%s", $0}'`
}
# ........................................................................

# ........................................................................
# transform // into /
# ........................................................................
#phlib_one_slash()
#{
#
## give a name to the function's argument
#_WHERE=$1
#
#$1=`echo $_WHERE | 
#    $phlib_AWKNAME '{ sub("//","/",$0); printf "%s", $0}'`
#
#}
## ........................................................................

# ........................................................................
#
# returns: 1   dirname($1) = .
#          2   dirname($1) = ..  
#          10  pathname starts with ./
#          20  pathname starts with ../ 
#          3   otherwise
#
# Warning: return, can only return numeric values!!!!
#
#
phlib_pathname_is_relative()
{

# give a name to the function's argument
_ARGV1=$1

_dir=`dirname $_ARGV1`

if test $_dir = "."
then
    RET_is_relative="1"
else

    if test $_dir = ".."
    then
        RET_is_relative="2"
    else

       RET_is_relative=`echo $_ARGV1 | $phlib_AWKNAME '{ if( index($1,"./")== 1) {
                                print "10"
                           }
                           else if( index($1,"../") == 1) {
                                print "20"
                           }
                           else {
                                print "3"
                           }
                           }'`

    fi
fi

return $RET_is_relative 
}
# ........................................................................

